/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.labsl.models.entities.pub

import com.persagy.service.models.SBaseEntity
import java.io.Serializable
import java.util.*
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 图例
 *
 * @author wx
 */
@Schema(description = "图例")
@Table(name = "labsl.graph_pub")
class GraphPub : SBaseEntity(), Serializable {

    /** 全局id */
    @Schema(description = "全局id" )
    @Id
    @Column(name = "id")
    var id: String? = null

    /** 图类型id */
    @Schema(description = "图类型id",required = true )
    @Id
    @Column(name = "graph_id")
    var graphId: String? = null

    /** 图名称 */
    @Schema(description = "图名称")
    @Column(name = "name")
    var name: String? = null

    /** 图分类id */
    @Schema(description = "图分类id")
    @Column(name = "category_id")
    var categoryId: String? = null

    /** 项目id */
    @Schema(description = "项目id")
    @Column(name = "project_id")
    var projectId: String? = null

    /** 建筑id */
    @Schema(description = "建筑id")
    @Column(name = "building_id")
    var buildingId: String? = null

    /** 楼层id */
    @Schema(description = "楼层id")
    @Column(name = "floor_id")
    var floorId: String? = null

    /** 说明 */
    @Schema(description = "说明")
    @Column(name = "note")
    var note: String? = null

    /** 版本号 */
    @Schema(description = "版本号")
    @Column(name = "version")
    var version: String? = null

    @Schema(description = "系统图展示所需数据")
    var elements: ElementsPub? = null

    /** 移至回收站时间 */
    @Schema(description = "移至回收站时间")
    @Column(name = "del_time")
    var delTime: Date? = null

    /** 移至回收站时间 */
    @Schema(description = "移至回收站时间 , false 正常，true 以至回收站")
    @Column(name = "is_available")
    var isAvailable: Boolean? = false

    /** 内部版本号 */
    @Schema(description = "内部版本号")
    @Column(name = "tag_version")
    var tagVersion: Int? = null

//    /** 内部版本号 */
//    @Schema(description = "是否发布（true 发布、false 未发布）")
//    @Column(name = "is_pub")
//    var isPub: Boolean = false

    /** 图片Key */
    @Schema(description = "图片Key")
    @Column(name = "pic")
    var pic: String? = null

    /** 图状态（1一般，2待审核，3审核完成，0发布） */
    @Schema(description = "图状态（1一般，2待审核，3审核完成，0发布）")
    @Column(name = "state")
    var state: Int? = null

    /** 页面尺寸 */
    @Schema(description = "页面尺寸")
    @Column(name = "page_size")
    var pageSize: HashMap<String, Any?>? = null

    /** 标签 */
    @Schema(description = " 标签 ")
    @Column(name = "label")
    var label: ArrayList<String>? = null

} // Class Graph