/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.labsl.models.entities.pub

import com.persagy.server.labsl.models.entities.Pos
import com.persagy.server.labsl.models.entities.Size
import com.persagy.service.models.SBaseEntity
import java.io.Serializable
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 图例节点
 *
 * @author wx
 */
@ApiModel(description = "图例节点")
@Table(name = "labsl.node_pub")
class NodePub : SBaseEntity(), Serializable {

    /** 全局id */
    @Schema(description = "全局id" )
    @Id
    @Column(name = "id")
    var id: String? = null

    /** 图例节点id */
    @Schema(description = "图例节点id",required = true )
    @Id
    @Column(name = "node_id")
    var nodeId: String? = null

    /** 图例节点名称 */
    @Schema(description = "图例节点名称")
    @Column(name = "name")
    var name: String? = null

    /** 图例类型 None/Line/Zone/Image:非图例/线条/区域类型/图标 */
    @Schema(description = "图例类型 None/Line/Zone/Image:非图例/线条/区域类型/图标")
    @Column(name = "graph_element_type")
    var graphElementType: String? = null

    /** 图元ID */
    @Schema(description = "图元ID")
    @Column(name = "graph_element_id")
    var graphElementId: String? = null

    /** 图例数量 */
    @Schema(description = "图例数量")
    @Column(name = "num")
    var num: Int? = null

    /** 节点类型(image / zone) */
    @Schema(description = "节点类型(image / zone)")
    @Column(name = "type")
    var type: String? = null

    /** 位置信息 */
    @Schema(description = "位置信息")
    @Column(name = "pos")
    var pos: Pos? = null

    /** 缩放 */
    @Schema(description = "缩放")
    @Column(name = "scale")
    var scale: Pos? = null

    /** 旋转 */
    @Schema(description = "旋转")
    @Column(name = "rolate")
    var rolate: Pos? = null

    /** 大小 */
    @Schema(description = "大小")
    @Column(name = "size")
    var size: Size? = null

    /** 轮廓线 */
    @Schema(description = "轮廓线")
    @Column(name = "outline")
    var outline: ArrayList<ArrayList<Pos>>? = null

    @Schema(description = "应用自定义")
    @Column(name = "properties")
    var properties : HashMap<String,Any?>? = null

    /** 图id */
    @Schema(description = "图id")
    @Column(name = "graph_id")
    var graphId: String? = null

    /** 锚点列表 */
    @Schema(description = "锚点列表")
    var anchorList: ArrayList<AnchorPub>? = null

    @Schema(description = "图例节点与对象的关系")
    var attachObjectIds: ArrayList<AttachObjectIdsPub>? = null

    /** 图状态（1一般，2待审核，3审核完成，0发布） */
    @Schema(description = "图状态（1一般，2待审核，3审核完成，0发布）")
    @Column(name = "state")
    var state: Int? = null

    @Schema(description = "线的绘图样式")
    @Column(name = "style")
    var style : HashMap<String,Any?>? = null

} // Class